#include <stdio.h>
#include <stdlib.h>

#include "table.h"
#include "nodes.h"


/*
 * Laboratorio di Programmazione AA 2004-05
 * Verifica il primo modulo del progetto.
 */
int main(int argc, char *argv[]){
    char *dirname;
    struct table *node_tb;
    struct telist *ls;
    /* inizializza il nome della directory da leggere */
    if (--argc == 0) {
	dirname = "."; /* usa la dir corrente */
    } else {
	dirname = *++argv; /* dir letta dalla linea di comando */
    }
    printf("'Directory: %s'\n", dirname);
    /* crea la tavola dei file */
    node_tb = create_node_table(dirname);
    /* scandisci la lista dei file letti */
    for (ls = node_tb->ls; ls != NULL; ls = ls->next) {
	/* cerca il nodo nella tavola:
	 * serve a provare la table_search
	 */
	struct tabelem *pte = table_search(node_tb, ls->el->key);
	if (pte != ls->el) {
	    /* problema: i due tabelem sarebbe dovuti essere uguali */
	    printf("Errore nella tavola!");
	    return -1;
	}
	/* stampa la chiave */
	printf("%s\n", pte->key);
    }
    return 0;
}
