#include "nodes.h"
#include "table.h"

struct table *create_node_table(char *dirname){
	DIR *d;
	struct dirent *info;
	struct table *t;
	struct tabelem *e;
	int i;
	printf("inserisci la dimensione della tavola hash: ");
	scanf("%d", &HTABDIM);
	/*questa parte alloca la nuova tavola e tutte le sottostrutture*/
	t = malloc(sizeof(struct table));
	if(t!=NULL){
		t->htable = malloc(sizeof(struct hashtable));
		if(t->htable!=NULL){
			t->htable->array = calloc(HTABDIM, sizeof(HTABELEM));
			if(t->htable->array!=NULL){
			/*inizializza e riempie la tavola*/
				table_init(t);
				d = opendir(dirname);
				while(info = readdir(d)){
					e = table_ins(t, info->d_name);
					if(e==NULL) return NULL;
				}
				closedir(d);
			}
		}
	}
	return t;
}
