#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct htabelem{
	struct tabelem *data;
	struct htabelem *next;
}*HTABELEM;

typedef struct hashtable{
	int hdim;
	HTABELEM *array;
}*HASHTABLE;

int HTABDIM;

int hash_funct(HASHTABLE ht, char *k);

void htable_init(HASHTABLE ht);

int htable_full(HASHTABLE ht);

struct tabelem *htable_ins(HASHTABLE ht, char *k);

struct tabelem *htable_search(HASHTABLE ht, char *k);
